type var = string

type t =
    | TVar of var                  
    | TCst of value                    
    | TApp of t * t        
    | TFun of var * t          
    | TLet of var * t * t     
    | TIf of t * t * t     
    | TAdd of t * t 
    | TSub of t * t 
    | TMul of t * t
    | TEq of t * t
    | TLeq of t * t
    | TLetTuple of var * var * t * t
    | TPair of t * t      
    | TFix of var * var * t 
    | TRef of t
    | TDeref of t 
    | TAss of t * t
    | TSeq of t * t
    
and value = 
  | VUnit 
  | VInt of int
  | VBool of bool
  | VFun of (value -> value)
  | VPair of value * value
  | VRef of value ref
